(leetcode算法题)769. 最多能完成排序的块

Q1. 是否能用贪心算法?为什么?

先预设一个策略,每当当前的numsi满足可以 "成块",就直接让这个数成块,也就是说之后的遍历过程中不会将这个数在考虑到自己的块内,

"成块" 是指只要只需要将numsi放到前面的某个子数组的尾部,然后将这个子数组进行排序,就能得到一个拥有连续自然数的子数组,就称为成块

能够使用谈心算法是因为有如下规律

规律1. 以numsi为结尾的成块的子数组,其中的最大值不能小于 i

反证法:假设numsi为结尾的成块的子数组,其中最大值小于 i

那么对这个子数组进行排序后,最后一个值即为maxval,且其下标标定位i

子数组最开始的那个下标设为j, 那么子数组中应该有 i - j + 1个元素

又根据成块的定义,这里将会缺少自然数填满i - j + 1个位置矛盾

故,想要成块,子数组的最大值不能小于 i

下面以图示的方法进一步说明,假设红线前的0 1 2已经成块了

如果 nums7 < 7 那么一定不能成块,因为此时只能有 6 5 4 3 2 1 0 能放入这8个黑框中,

规律2. 以numsi为结尾的成块的子数组,其中的最大值不能大于 i

证明与上面类似,矛盾之处在于如果最大值大于 i ,则将会多出来一个元素

所以要想成块只能是maxval == i

cpp 复制代码
class Solution {
public:
    int maxChunksToSorted(vector<int>& arr) {
        int n = arr.size();
        int ret = 0;
        int curmax = 0;
        for(int i = 0; i < n; ++i){
            curmax = max(curmax, arr[i]);
            if(curmax == i){
                ret++;
            }
        }
        return ret;
    }
};
相关推荐
怕浪猫3 小时前
RAG 面试 6 连问,从原理到优化全部覆盖
python·算法·面试
无线通信科研笔记3 小时前
IEEE TVT 2026 论文精读与完整复现|相位误差如何重塑近场 RIS 的幅相响应
论文阅读·人工智能·python·算法·论文笔记
mmmmath_34 小时前
二叉树の递归遍历
算法
All for pursuit.4 小时前
【位运算-1】338.比特位计数
数据结构·c++·算法·leetcode
小师兄吃牛肉5 小时前
C语言中的nullptr有必要吗
c语言·c++·算法
一只小小的芙厨6 小时前
【线性DP】
学习·算法·动态规划
奋发向前wcx7 小时前
CSP-J复赛模拟赛5 王晨旭补题 2026.10.5
算法
罗湖老棍子8 小时前
C Looooops(信息学奥赛一本通- P1640)
算法·数论·同余·裴蜀定理·扩展欧几里得
飘尘10 小时前
从"算子"到"AI Infra":大模型背后看不见的那群人在忙什么
人工智能·算法·面试
夏幻灵11 小时前
每日一题:LeetCode 3:无重复字符的最长子串——滑动窗口思路详解
算法·leetcode·职场和发展